//interfacing with 7seg-CommonCathode/RTC-DS3231// NO BOTTOM
//FOSC-20MHZ
//CLOCK-100KHZ
// 16F877A

//manipulate 7 segment

#include<xc.h>

#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable bit (PWRT enabled)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage (Single-Supply) In-Circuit Serial Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EEPROM Memory Code Protection bit (Data EEPROM code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off; all program memory may be written to by EECON control)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)


#define _XTAL_FREQ 20000000 //We are running on 20MHz crystal 

//Define the 7-seg control
#define s1 RC0
#define s2 RC1


/*Set the current value of date and time below*/
int sec = 00;
int min = 55;
int hour = 10;
int date = 06;
int month = 05;
int year = 18;
/*Time and Date Set*/


////#include "lcd.h" //Header for using LCD module
#include "PIC16F877a_I2C.h" // Header for using I2C protocal
#include "PIC16F877a_DS3231.h" //Header for using DS3231 RTC module

unsigned char Display (unsigned char digit)
  {
    //unsigned int pattern;
    unsigned char  SEGMENT_MAP[10] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7C,0x7F,0x6F};
    return (SEGMENT_MAP[digit]) ;
    //pattern =  SEGMENT_MAP[digit] ;  //The pattern to return
    //return (pattern);
  }


int main()
{

    
    
    TRISC = 0xFC; //RC0, RC1 output pin
    TRISD = 0x00; //Make Port D pins as outptu for SEGMENTS 
    
      
    PORTD = 0x00;
    
   
    
    I2C_Initialize(100); //Initialize I2C Master with 100KHz clock
        
    Set_Time_Date(); //set time and date on the RTC module
    

while(1)
  {
 
    Update_Current_Date_Time(); //Read the current date and time from RTC module
    
    //Split the into char to display on lcd
     unsigned char sec_0 = sec%10;
     unsigned char sec_1 = (sec/10);    
     
    
    //Display the Time sec
     
     PORTD = Display(sec_0);  s2 = 1; 
     __delay_ms(5); s2 = 0;
     
     PORTD = Display(sec_1); s1 = 1; 
     __delay_ms(5); s1 = 0;

     
  }

    return 0;
}